 
create table ParcelaPW
(
    CodigoEmp           char(2)                not null,
    CodigoUnidade       char(8)                not null,
    TipoEmpresa         char(1)                not null,
    CodigoEmpresa       char(5)                not null,
    CodigoDocumento     char(10)               not null,
    Serie               char(3)                not null,
    Numero              char(8)                not null,
    Parcela             char(2)                not null,
    Emissao             datetime               null    ,
    Vencimento          datetime               null    ,
    Recebimento         datetime               null    ,
    BancoCobranca       char(3)                not null,
    AgenciaCobranca     char(10)               not null,
    ContaCobranca       char(12)               not null,
    Valor               dec(12,2)              null    ,
    PercentualMultaP    dec(5,2)               null    ,
    ValorMultaP         dec(12,2)              null    ,
    PercentualJurosP    dec(5,2)               null    ,
    ValorDescontoP      dec(12,2)              null    ,
    PercentualDesctP    dec(5,2)               null    ,
    ValorMulta          dec(12,2)              null    ,
    ValorJuros          dec(12,2)              null    ,
    ValorDesconto       dec(12,2)              null    ,
    ValorIRRF           dec(12,2)              null    ,
    ValorINSS           dec(12,2)              null    ,
    ValorCSLL           dec(12,2)              null    ,
    ValorCOFINS         dec(12,2)              null    ,
    ValorPIS            dec(12,2)              null    ,
    ValorISS            dec(12,2)              null    ,
    ValorRURAL          dec(12,2)              null    ,
    ValorRAT            dec(12,2)              null    ,
    ValorSENAR          dec(12,2)              null    ,
    ValorOutroC         dec(12,2)              null    ,
    ValorOutroD         dec(12,2)              null    ,
    BancoRecebimento    char(3)                not null,
    AgenciaRecebimento  char(10)               not null,
    ContaRecebimento    char(12)               not null,
    DoctoRecebimento    char(10)               null    ,
    NumeroRecebimento   char(10)               null    ,
    IDBancaria          char(20)               null    ,
    RefBancaria         char(10)               null    ,
    CodigoCarteira      char(2)                null    ,
    Contabilizado       char(1)                null    ,
    Programada          datetime               null    
);

INSERT INTO ParcelaPW SELECT 
CodigoEmp, CodigoUnidade, TipoEmpresa, CodigoEmpresa, CodigoDocumento, Serie,
Numero, Parcela, Emissao, Vencimento, Recebimento, BancoCobranca, AgenciaCobranca,
ContaCobranca, Valor, PercentualMultaP, ValorMultaP, PercentualJurosP, ValorDescontoP,
PercentualDesctP, ValorMulta, ValorJuros, ValorDesconto, ValorIRRF, ValorINSS, ValorCSLL, ValorCOFINS, ValorPIS, ValorISS, 0, 0, 0, ValorOutroC,
ValorOutroD, BancoRecebimento, AgenciaRecebimento, ContaRecebimento, DoctoRecebimento,
NumeroRecebimento, IDBancaria, RefBancaria, CodigoCarteira, Contabilizado, Programada FROM ParcelaP;

alter table AplicacaoP drop constraint FK_APLICACA_PAPAPP;
alter table Bordero drop constraint FK_BORDERO_PAPBOR_PARCELAP;
alter table Cheque drop constraint FK_CHEQUE_PAPCHQ_PARCELAP;
alter table CodBarrasP drop constraint FK_CodBarrasP_DOPPAP_DOCUMENT;
alter table CreditoConta drop constraint FK_PAPCCT;
alter table DocImpostoP drop constraint FK_DocImpostoP_ParcelaP;
alter table ObservacaoP drop constraint FK_OBSERVAC_PAPOBP_PARCELAP;
alter table RemessaP drop constraint FK_REMESSAP_PAPRMP_PARCELAP;
alter table RetornoP drop constraint fk_PaPRtP;
alter table ParcelaP drop constraint FK_PARCELAP_DOPPAP_DOCUMENT;
alter table ParcelaP drop constraint PK_PARCELAP;

DROP TABLE ParcelaP; 
 
create table ParcelaP
(
    CodigoEmp           char(2)                not null,
    CodigoUnidade       char(8)                not null,
    TipoEmpresa         char(1)                not null,
    CodigoEmpresa       char(5)                not null,
    CodigoDocumento     char(10)               not null,
    Serie               char(3)                not null,
    Numero              char(8)                not null,
    Parcela             char(2)                not null,
    Emissao             datetime               null    ,
    Vencimento          datetime               null    ,
    Recebimento         datetime               null    ,
    BancoCobranca       char(3)                not null,
    AgenciaCobranca     char(10)               not null,
    ContaCobranca       char(12)               not null,
    Valor               dec(12,2)              null    ,
    PercentualMultaP    dec(5,2)               null    ,
    ValorMultaP         dec(12,2)              null    ,
    PercentualJurosP    dec(5,2)               null    ,
    ValorDescontoP      dec(12,2)              null    ,
    PercentualDesctP    dec(5,2)               null    ,
    ValorMulta          dec(12,2)              null    ,
    ValorJuros          dec(12,2)              null    ,
    ValorDesconto       dec(12,2)              null    ,
    ValorIRRF           dec(12,2)              null    ,
    ValorINSS           dec(12,2)              null    ,
    ValorCSLL           dec(12,2)              null    ,
    ValorCOFINS         dec(12,2)              null    ,
    ValorPIS            dec(12,2)              null    ,
    ValorISS            dec(12,2)              null    ,
    ValorRURAL          dec(12,2)              null    ,
    ValorRAT            dec(12,2)              null    ,
    ValorSENAR          dec(12,2)              null    ,
    ValorOutroC         dec(12,2)              null    ,
    ValorOutroD         dec(12,2)              null    ,
    BancoRecebimento    char(3)                not null,
    AgenciaRecebimento  char(10)               not null,
    ContaRecebimento    char(12)               not null,
    DoctoRecebimento    char(10)               null    ,
    NumeroRecebimento   char(10)               null    ,
    IDBancaria          char(20)               null    ,
    RefBancaria         char(10)               null    ,
    CodigoCarteira      char(2)                null    ,
    Contabilizado       char(1)                null    ,
    Programada          datetime               null    
);

INSERT INTO ParcelaP SELECT * FROM ParcelaPW; 

alter table ParcelaP
    add constraint PK_PARCELAP primary key (CodigoEmp, CodigoUnidade,TipoEmpresa, CodigoEmpresa,CodigoDocumento, Serie, Numero, Parcela);
alter table ParcelaP
    add constraint FK_PARCELAP_DOPPAP_DOCUMENT foreign key  (CodigoEmp, CodigoUnidade, TipoEmpresa, CodigoEmpresa, CodigoDocumento, Serie, Numero)
       references DocumentoP (CodigoEmp, CodigoUnidade, TipoEmpresa, CodigoEmpresa, CodigoDocumento, Serie, Numero);
alter table AplicacaoP
    add constraint FK_APLICACA_PAPAPP foreign key  (CodigoEmp, CodigoUnidade, TipoEmpresa, CodigoEmpresa, CodigoDocumento, Serie, Numero, Parcela) 
       references ParcelaP (CodigoEmp, CodigoUnidade, TipoEmpresa, CodigoEmpresa, CodigoDocumento, Serie, Numero, Parcela);
alter table Bordero
    add constraint FK_BORDERO_PAPBOR_PARCELAP foreign key  (CodigoEmp, CodigoUnidade, TipoEmpresa, CodigoEmpresa, CodigoDocumento, Serie, Numero, Parcela)
       references ParcelaP (CodigoEmp, CodigoUnidade, TipoEmpresa, CodigoEmpresa, CodigoDocumento, Serie, Numero, Parcela);
alter table Cheque
    add constraint FK_CHEQUE_PAPCHQ_PARCELAP foreign key  (CodigoEmp, CodigoUnidade, TipoEmpresa, CodigoEmpresa, CodigoDocumento, Serie, Numero, Parcela)
       references ParcelaP (CodigoEmp, CodigoUnidade, TipoEmpresa, CodigoEmpresa, CodigoDocumento, Serie, Numero, Parcela);
alter table CodBarrasP
    add constraint FK_CodBarrasP_DOPPAP_DOCUMENT foreign key  (CodigoEmp, CodigoUnidade, TipoEmpresa, CodigoEmpresa, CodigoDocumento, Serie, Numero, Parcela)
       references ParcelaP (CodigoEmp, CodigoUnidade, TipoEmpresa, CodigoEmpresa, CodigoDocumento, Serie, Numero, Parcela);
alter table CreditoConta
    add constraint FK_PAPCCT foreign key  (CodigoEmp, CodigoUnidade, TipoEmpresa, CodigoEmpresa, CodigoDocumento, Serie, Numero, Parcela)
       references ParcelaP (CodigoEmp, CodigoUnidade, TipoEmpresa, CodigoEmpresa, CodigoDocumento, Serie, Numero, Parcela);
alter table DocImpostoP
    add constraint FK_DocImpostoP_ParcelaP foreign key  (CodigoEmp, CodigoUnidade, TipoEmpresa, CodigoEmpresa, CodigoDocumento, Serie, Numero, Parcela)
       references ParcelaP (CodigoEmp, CodigoUnidade, TipoEmpresa, CodigoEmpresa, CodigoDocumento, Serie, Numero, Parcela);
alter table ObservacaoP
    add constraint FK_OBSERVAC_PAPOBP_PARCELAP foreign key  (CodigoEmp, CodigoUnidade, TipoEmpresa, CodigoEmpresa, CodigoDocumento, Serie, Numero, Parcela)
       references ParcelaP (CodigoEmp, CodigoUnidade, TipoEmpresa, CodigoEmpresa, CodigoDocumento, Serie, Numero, Parcela);
alter table RemessaP
    add constraint FK_REMESSAP_PAPRMP_PARCELAP foreign key  (CodigoEmp, CodigoUnidade, TipoEmpresa, CodigoEmpresa, CodigoDocumento, Serie, Numero, Parcela)
       references ParcelaP (CodigoEmp, CodigoUnidade, TipoEmpresa, CodigoEmpresa, CodigoDocumento, Serie, Numero, Parcela);
alter table RetornoP
    add constraint fk_PaPRtP foreign key  (CodigoEmp, CodigoUnidade, TipoEmpresa, CodigoEmpresa, CodigoDocumento, Serie, Numero, Parcela)
       references ParcelaP (CodigoEmp, CodigoUnidade,TipoEmpresa, CodigoEmpresa,  CodigoDocumento, Serie, Numero, Parcela);
 
create index ParcelaP_FK1 on ParcelaP (CodigoEmp, RefBancaria);
create index ParcelaP_FK2 on ParcelaP (CodigoEmp, CodigoUnidade, TipoEmpresa, CodigoEmpresa, CodigoDocumento, Serie, Numero, Vencimento, Recebimento );
create index ParcelaP_FK3 on ParcelaP (CodigoEmp, CodigoUnidade, TipoEmpresa, CodigoEmpresa, CodigoDocumento, Serie, Numero, Emissao, Recebimento );
create index ParcelaP_FK4 on ParcelaP (CodigoEmp, CodigoUnidade, TipoEmpresa, CodigoEmpresa, CodigoDocumento, Serie, Numero, Recebimento );
create index ParcelaP_FK5 on ParcelaP (Vencimento, Recebimento );
create index ParcelaP_FK6 on ParcelaP (Emissao, Recebimento );
create index ParcelaP_FK7 on ParcelaP (Recebimento );
create index ParcelaP_FK8 on ParcelaP (CodigoEmp, BancoRecebimento, AgenciaRecebimento, ContaRecebimento, DoctoRecebimento );
create index ParcelaP_FK9 on ParcelaP (CodigoEmp, CodigoCarteira, IdBancaria );
create index ParcelaP_FK10 on ParcelaP (CodigoEmp, CodigoUnidade, TipoEmpresa, CodigoEmpresa, CodigoDocumento, Serie, Numero, Parcela, DoctoRecebimento );
create index ParcelaP_FK11 on ParcelaP (CodigoEmp, Recebimento, TipoEmpresa, CodigoEmpresa );

GRANT ALL ON ParcelaP TO BYTEC;

DROP TABLE ParcelaPW;